/**
 * name: use-spotlight@1.0.0
 * desc: A react hook that generates 'spotlight' for active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
import { useState as u, useRef as d, useCallback as v, useEffect as b } from "react";
const m = ([p, c, e, i]) => ({
  content: "",
  display: "block",
  position: "absolute",
  top: "0",
  left: "0",
  width: `${e}px`,
  height: `${i}px`,
  transform: `translate(${p}px, ${c}px)`,
  transitionProperty: "transform, width, height",
  transitionDuration: "200ms",
  background: "rgba(255 0 0 / 0.1)",
  // TODO
  pointerEvents: "none"
}), z = [0, 0, 0, 0], l = { x: 0, y: 0, width: 0, height: 0 }, $ = (p = {}) => {
  const [c, e] = u(z), [i, f] = u(l), [s, g] = u(l);
  let h = d(null), y = d(null);
  const S = v(
    (t) => {
      h.current = t;
      const n = (t == null ? void 0 : t.getBoundingClientRect()) ?? l;
      f({
        ...n,
        x: n.x - t.scrollLeft,
        y: n.y - t.scrollTop
      });
    },
    [f]
  ), w = v(
    (t) => {
      y.current = t, g((t == null ? void 0 : t.getBoundingClientRect()) ?? l);
    },
    [g]
  );
  return b(() => {
    e([
      s.x - i.x,
      s.y - i.y,
      s.width,
      s.height
    ]);
  }, [i, s, e]), b(() => {
    const t = h.current, n = y.current;
    if (!t || !n)
      return () => e(z);
    let o = null;
    const R = () => {
      const a = t.getBoundingClientRect(), x = {
        ...a,
        x: a.x - t.scrollLeft,
        y: a.y - t.scrollTop
      }, r = n.getBoundingClientRect();
      e([r.x - x.x, r.y - x.y, r.width, r.height]);
    };
    typeof ResizeObserver < "u" && (o = new ResizeObserver(R), o.observe(t), o.observe(n)), R();
    const C = t.style.position;
    return t.style.position = "relative", () => {
      t.style.position = C, o == null || o.disconnect();
    };
  }, [i, s, e]), {
    stage: S,
    actor: w,
    style: m(c),
    size: c
  };
}, k = null;
export {
  k as default,
  $ as useSpotlight
};
